/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __HOST_CALLS_H__
#define __HOST_CALLS_H__

#include <windows.h>
#include "vbox_hdrs.h"
#include "CopyFilesHandler.h"
#include "FilesCopier.h"

UINT
HostCall_DragDropFiles(
    UINT ClientId,
    UINT DropHandle
    );

UINT
HostCall_CFH_Begin(
    IN uint32_t ClientId,
    IN uint32_t DropHandle,
    OUT uint32_t *pHandle
    );


UINT
HostCall_CFH_GetBuildingListStatus(
    IN  UINT ClientId,
	IN  UINT Handle,
	OUT PCOPY_FILES_BUILDING_LIST_STATUS pCopyFilesBuildingListStatus
	);


UINT
HostCall_CFH_GetCurrentFileName(
    IN  UINT ClientId,
	IN  UINT Handle,
	OUT PCOPY_FILES_GET_CURRENT_FILENAME pCopyFilesGetCurrentFileName
	);

UINT
HostCall_CFH_GetCurrentStream(
    IN  UINT ClientId,
	IN  UINT Handle,
	IN OUT PVOID pBuffer,
	IN  UINT BufferSize,
	OUT PUINT pBytesCopied,
	OUT PUINT64 pStreamOffset
	);


UINT
HostCall_CFH_MoveToNextItem(
    IN  UINT ClientId,
	IN  UINT Handle,
	UINT64 ItemId
	);


UINT
HostCall_CFH_End(
	IN  UINT ClientId,
	IN  UINT Handle
	);


class CHostFromGuestCopierHelper : public CFileCopierHelper
{

public:

    virtual
    UINT
    CFH_Begin(
        IN uint32_t ClientId,
        IN uint32_t DropHandle,
        OUT uint32_t *pHandle
        ){ return HostCall_CFH_Begin( ClientId, DropHandle, pHandle );  }

    virtual
    UINT
    CFH_GetBuildingListStatus(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	OUT PCOPY_FILES_BUILDING_LIST_STATUS pCopyFilesBuildingListStatus
    	){  return HostCall_CFH_GetBuildingListStatus(ClientId,Handle,pCopyFilesBuildingListStatus); }

    virtual
    UINT
    CFH_GetCurrentFileName(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	OUT PCOPY_FILES_GET_CURRENT_FILENAME pCopyFilesGetCurrentFileName
    	){ return HostCall_CFH_GetCurrentFileName(ClientId,Handle,pCopyFilesGetCurrentFileName); }

    virtual
    UINT
    CFH_GetCurrentStream(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	IN OUT PVOID pBuffer,
    	IN  UINT BufferSize,
    	OUT PUINT pBytesCopied,
    	OUT PUINT64 pStreamOffset
    	){return HostCall_CFH_GetCurrentStream(ClientId,Handle,pBuffer,BufferSize,pBytesCopied,pStreamOffset); }
    

    virtual
    UINT
    CFH_MoveToNextItem(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	UINT64 ItemId
    	)
    { return HostCall_CFH_MoveToNextItem(ClientId,Handle,ItemId); }

    virtual
    UINT
    CFH_End(
    	IN  UINT ClientId,
    	IN  UINT Handle
    	){ return HostCall_CFH_End( ClientId, Handle ); }
    
}; //CHostFromGuestCopierHelper

#endif //__HOST_CALLS_H__

