/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <windows.h>
#include "DllMain.h"
#include "ExplorerClassFactory.h"
#include "guid.h"
#include "DbgPrintf.h"
#include "PasteFilesFromHost.h"
#include "GuestServer.h"
#include "WinTools.h"
#include "Globals.h"
//#include <iprt/cdefs.h>

HINSTANCE g_DllHinst = NULL;
ULONG g_DllRefs = 0;

HINSTANCE
CALLBACK
GetModuleInstance()
{
	return g_DllHinst;
}

EXTERN_C
BOOL
APIENTRY
DllMain(
    HINSTANCE aHandle,
    DWORD  aReason,
    LPVOID aReserved
    )
{
    static BOOL s_bComWasInit = FALSE;

    if ( DLL_PROCESS_ATTACH == aReason )
    {
        g_DllHinst = aHandle;

        DbgPrintf( "GSHELL ContextMenuHandler: attaching to process %u\n", GetCurrentProcessId() );

        //init com is required for converting .lnk files
        //add PathFromPoint

        /*if ( !SUCCEEDED( CoInitialize( NULL ) ) )
        {
            DbgPrintf( "Cannot init OLE for %u\n", GetCurrentProcessId() );
            return FALSE;
        }
        else
        {
            DbgPrintf( "CoInitialize: Success\n" );
            s_bComWasInit = TRUE;
        }*/

    }
    else if ( DLL_PROCESS_DETACH == aReason )
    {
        DbgPrintf( "GSHELL ContextMenu:: detaching from process %u\n", GetCurrentProcessId() );

        /*if ( s_bComWasInit )
        {
            s_bComWasInit = FALSE;
            CoUninitialize();
        }*/
    }

    return TRUE;
}


STDAPI
DllCanUnloadNow()
{
    //DbgPrintf( "DllCanUnloadNow called\n" );

    if ( g_DllRefs == 0 )
        return S_OK;
    else
        return S_FALSE;
}


STDAPI
DllGetClassObject(
    REFCLSID rclsid,
    REFIID riid,
    LPVOID *ppv
    )
{
    HRESULT retcode = CLASS_E_CLASSNOTAVAILABLE;

    //DbgPrintf( "DllGetClassObject called\n" );

    if ( IsEqualIID( rclsid, CLSID_VMGuestClipbrdExtProvider ) )
    {
        CExplorerClassFactory *pVMGuestClipbrdExtProvider = new CExplorerClassFactory;

        if ( pVMGuestClipbrdExtProvider )
        {
            retcode = pVMGuestClipbrdExtProvider->QueryInterface(
                riid,
                ppv
                );

            if ( retcode == NOERROR )
            {
                //DbgPrintf( "pVMGuestClipbrdExtProvider->QueryInterface succeeded\n" );
                return retcode;
            }

            delete pVMGuestClipbrdExtProvider;
        }
        else
        {
            retcode = E_OUTOFMEMORY;
        }
    }

    //error
    *ppv = NULL;
    return retcode;
}

VOID
RemoveQuotesW(
    WCHAR *pStr
    )
{
    int Strlen = wcslen( pStr );

    if ( pStr[0] == L'\"' && pStr[Strlen-1] == L'\"' )
    {
        size_t i = 0;
        size_t k = 1;

        do
        {
            pStr[ i ] = pStr[k];

            if ( k == Strlen - 1 )
            {
                pStr[ i ] = 0;
                break;
            }

            i++,k++;

        } while ( pStr[ i ] != 0 );
    }

}

EXTERN_C
VOID
__stdcall
Paste64W(
    //LPCWSTR lpszFolderName
    HWND hWnd, HINSTANCE hInst, LPCWSTR cmd, DWORD nCmdShow
    )
{

    typedef BOOL(__stdcall *PWow64DisableWow64FsRedirection)(    PVOID *pParam    );
    typedef BOOL(__stdcall *PWow64RevertWow64FsRedirection)( PVOID Param );

    WCHAR wszFolderName[MAX_PATH+2] = L"";

    wcsncpy_s( wszFolderName, ARRAYSIZE(wszFolderName), cmd, _TRUNCATE );
    RemoveQuotesW( wszFolderName );

    //rundll32 "c:\src\VirtualBox-4.1.8_OSE\out\win.x86\release\bin\additions\GuestShellDll.dll",Paste64 c:\windows 

    DbgPrintf( "Paste64 called\n"  );

    PWow64DisableWow64FsRedirection pfnWow64DisableWow64FsRedirection = (PWow64DisableWow64FsRedirection)GetProcAddress(
            GetModuleHandle( "kernel32.dll"),
            "Wow64DisableWow64FsRedirection"            
            );    

    PWow64RevertWow64FsRedirection pfnWow64RevertWow64FsRedirection = (PWow64RevertWow64FsRedirection)GetProcAddress(
            GetModuleHandle( "kernel32.dll"),
            "Wow64RevertWow64FsRedirection"            
            );    

    if ( wszFolderName[0] == 0 )
        return;

    PVOID RevertParam = NULL;
    BOOL bRedirWasDisabled = FALSE;

    if ( pfnWow64DisableWow64FsRedirection )
        bRedirWasDisabled = pfnWow64DisableWow64FsRedirection( &RevertParam );

    DbgPrintf( "call PasteFilesFromHost for %ws\n", wszFolderName );

    PasteFilesFromHost( wszFolderName );

    if ( bRedirWasDisabled && pfnWow64RevertWow64FsRedirection )
        pfnWow64RevertWow64FsRedirection( RevertParam );
    
}




EXTERN_C
VOID
__stdcall
RDLL_RunGuestServer(
    //LPCWSTR lpszFolderName
    HWND hWnd, HINSTANCE hInst, LPCWSTR cmd, DWORD nCmdShow
    )
{
    RunGuestServer();
}

