/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _GUEST_HOST_STRUCTS_H_
#define _GUEST_HOST_STRUCTS_H_


#pragma pack (1)

typedef struct _VBOX_SHARED_CFH_BEGIN_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;

    HGCMFunctionParameter ErrorCode; //OUT UINT
    HGCMFunctionParameter DropHandle; // IN
    HGCMFunctionParameter Handle; //OUT UINT


} VBOX_SHARED_CFH_BEGIN_STRUCT; 


typedef struct _VBOX_SHARED_CFH_END_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    
    HGCMFunctionParameter ErrorCode; //OUT UINT
    HGCMFunctionParameter Handle; //IN UINT
        
} VBOX_SHARED_CFH_END_STRUCT;

typedef struct _VBOX_SHARED_CFH_GET_BUILDING_LIST_STATUS_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    
    HGCMFunctionParameter ErrorCode; //OUT UINT
    HGCMFunctionParameter Handle; //IN UINT
    HGCMFunctionParameter StatusInfo; //OUT COPY_FILES_BUILDING_LIST_STATUS

    
} VBOX_SHARED_CFH_GET_BUILDING_LIST_STATUS_STRUCT;


typedef struct _VBOX_SHARED_CFH_GETCURRENTFILENAME_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    
    HGCMFunctionParameter ErrorCode; //OUT UINT
    HGCMFunctionParameter Handle; //IN UINT    
    HGCMFunctionParameter FileNameInfo; //OUT COPY_FILES_GET_CURRENT_FILENAME
    
} VBOX_SHARED_CFH_GETCURRENTFILENAME_STRUCT;

typedef struct _VBOX_SHARED_CFH_GET_CURRENTSTREAM_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    
    HGCMFunctionParameter ErrorCode; //OUT UINT
    HGCMFunctionParameter Handle; //IN UINT    
    HGCMFunctionParameter Buffer; //IN OUT PTR
    HGCMFunctionParameter BytesCopied; //OUT UINT
    HGCMFunctionParameter StreamOffset; //OUT UIN64
    
    
    
} VBOX_SHARED_CFH_GET_CURRENTSTREAM_STRUCT;

typedef struct _VBOX_SHARED_MOVE_TO_NEXT_ITEM_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    HGCMFunctionParameter ErrorCode; //OUT UINT
    HGCMFunctionParameter Handle; //IN UINT    
    HGCMFunctionParameter NextItemId; //IN UIN64


} VBOX_SHARED_MOVE_TO_NEXT_ITEM_STRUCT;

typedef struct _VBOX_SHARED_HSM_PACKET_GUEST_CLIPBOARD_HAS_FILES_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    HGCMFunctionParameter  MajorMinorGuestOSVer; //UINT
    HGCMFunctionParameter  Is64bit;


}VBOX_SHARED_HSM_PACKET_GUEST_CLIPBOARD_HAS_FILES_STRUCT;

typedef struct _VBOX_SHARED_HSM_PACKET_WAIT_INPUT_FOR_GUEST_SERVER_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    HGCMFunctionParameter ErrorCode; //OUT UINT
    HGCMFunctionParameter Buffer; //IN OUT PTR
    HGCMFunctionParameter OutputBufferSize; //OUT
    HGCMFunctionParameter PacketId; //OUT UINT

} VBOX_SHARED_HSM_PACKET_WAIT_INPUT_FOR_GUEST_SERVER_STRUCT;

typedef struct _VBOX_SHARED_HSM_PACKET_SEND_OUTPUT_FROM_SERVER_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    HGCMFunctionParameter ErrorCode; //IN OUT? UINT
    HGCMFunctionParameter PacketId; //IN UINT
    HGCMFunctionParameter Buffer; //IN OUT PTR

} VBOX_SHARED_HSM_PACKET_SEND_OUTPUT_FROM_SERVER_STRUCT;

typedef struct _VBOX_SHARED_GET_VERSION_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    HGCMFunctionParameter VersionNumber; //OUT UINT

}VBOX_SHARED_GET_VERSION_STRUCT;

typedef struct _VBOX_SHARED_GET_DROPPED_FILES_LIST_STRUCT
{
    VBoxGuestHGCMCallInfo hdr;
    HGCMFunctionParameter DropHandle; //u32
    HGCMFunctionParameter FileListBuffer; //ptr
    HGCMFunctionParameter FileListBufferWriteln; //u32

}VBOX_SHARED_GET_DROPPED_FILES_LIST_STRUCT;

#pragma pack ()



#endif
