/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _EXPLORER_CLASS_FACTORY_H_
#define _EXPLORER_CLASS_FACTORY_H_

#include <windows.h>
#include <shlobj.h>
#include "DllMain.h"

class CExplorerClassFactory : public IClassFactory
{

public:

    //IUnknown

    STDMETHODIMP         QueryInterface(REFIID riid, PVOID *ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    //IClassFactory

    STDMETHODIMP         CreateInstance( IUnknown *punkOuter, REFIID iid, PVOID *ppv );
    STDMETHODIMP         LockServer( BOOL fLock ){ return NOERROR; };

    CExplorerClassFactory(){ m_cRef = 0; g_DllRefs++; }
    ~CExplorerClassFactory(){ g_DllRefs--; }

private:

	ULONG   m_cRef;


}; //CExplorerClassFactory



#endif //_EXPLORER_CLASS_FACTORY_H_
