/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _COMUTIL_H_
#define _COMUTIL_H_

#include <windows.h>
#include <specstrings.h>

#ifndef V_INT
#define V_INT( X ) V_UNION( X, intVal )
#endif

#ifndef V_UINT
#define V_UINT( X ) V_UNION( X, uintVal )
#endif

HRESULT
CreateInstanceWithProgID(
	IN LPCOLESTR lpszProgID,
	IN DWORD dwClsContext,
	OUT IDispatch **ppDispatch 
	);

HRESULT
Disp_PropGet(
	OUT VARIANT *pvResult,
	IN IDispatch *pDisp,
	IN LPCOLESTR lpPropName
	);

HRESULT
Disp_PropGetEx(
	OUT VARIANT *pvResult,
	IN IDispatch *pDisp,
	IN LPCOLESTR lpPropName,
	IN ULONG ArgCount,
	...
	);

HRESULT
Disp_PropSet(
	OUT VARIANT *pvResult OPTIONAL,
	IN IDispatch *pDisp,
	IN LPCOLESTR lpPropName,
	IN VARIANT *pPropValue
	);

HRESULT
Disp_PropSetEx(
	OUT VARIANT *pvResult OPTIONAL,
	IN IDispatch *pDisp,
	IN LPCOLESTR lpPropName,
	IN ULONG ArgCount,
	...
	);


HRESULT
Disp_CallMethod(
	OUT VARIANT *pvResult OPTIONAL,
	IN IDispatch *pDisp,
	IN LPCOLESTR lpMethodName,
	IN ULONG ArgCount,
	...
	);


#endif //_COMUTIL_H_
