
;    Copyright (C) 2012 NewestTools.com(AlexLe)
;
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <http://www.gnu.org/licenses/>. 

;Inno script file

#define APP_NAME "VMTransferFiles Host OS Module"
#define APP_VER "1.0"
#define BETA_STR ""
#define SHELLEXT_NAME "VMTransferFiles Host Module"

[Setup]

AppName = {#APP_NAME}
AppVerName = {#APP_NAME} {#APP_VER} {#BETA_STR}
OutputBaseFilename = setup_host
OutputDir=..\out\installers
VersionInfoVersion = {#APP_VER}
VersionInfoTextVersion = {#APP_VER}
AppId = {#APP_NAME}

ArchitecturesInstallIn64BitMode=x64
PrivilegesRequired = admin
UsePreviousAppDir = yes
CreateUninstallRegKey = yes
MinVersion = 0, 5.0

DefaultGroupName = {#APP_NAME}
DefaultDirName =   {pf}\VirtualBox
AppendDefaultDirName = no
EnableDirDoesntExistWarning = no
DirExistsWarning=no 
UninstallFilesDir={app}\{#APP_NAME}



LicenseFile=license.txt

[CustomMessages]

MsgCannotFindRequiredFiles=Cannot find required files.%nMake sure that you selected VirualBox install folder correctly.
MsgCannotValidateVirtualBoxFiles=Cannot validate VirtualBox file.%nMake sure that VirualBox install is not corrupted.%nDo you want to continue anyway?
MsgCannotMakeBackupOfFile=Cannot make backup of VirtualBox file.%nMake sure that VirualBox is not launched
MsgCannotReplaceFile=Cannot replace file.%nMake sure that VirualBox is not launched
SelDirPageDescriptionLabel=Select folder where VirtualBox is installed
SelDirLabel=Setup will modify files in the following folder.
FinishInstallNote=Note that you should reinstall this Host Module after every update of VirtualBox


[Files]

Source:"..\out\VBoxGuestPropSvc.dll";DestDir: "{app}";DestName:"VBoxGuestPropSvc.dll";Flags: dontcopy;
Source:"..\out\VBoxGuestPropSvc64.dll";DestDir: "{app}";DestName:"VBoxGuestPropSvc64.dll";Flags: dontcopy;
Source:"..\out\InnoInstExt.dll";DestName:"InnoInstExt.dll";Flags: dontcopy;
Source:"..\out\HostShellDll.dll";DestDir: "{app}\{#APP_NAME}";Flags:restartreplace uninsrestartdelete ignoreversion
Source:"..\out\HostShellDll64.dll";DestDir: "{app}\{#APP_NAME}";DestName:"HostShellDll64.dll";Flags:restartreplace uninsrestartdelete ignoreversion; Check: IsWin64
Source:"..\out\ShellNotifyAppHost.exe";DestDir: "{app}\{#APP_NAME}"; DestName: "VMTransferFiles.exe"; Flags:restartreplace uninsrestartdelete ignoreversion
Source: "Readme.txt"; DestDir: "{app}\{#APP_NAME}"; Flags: isreadme

[Registry]

;32bit
Root: HKCR32; Subkey: "CLSID\{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; ValueType: string; ValueName: ""; ValueData: "{#SHELLEXT_NAME} Context Menu"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "CLSID\{{C08BD772-82B5-433F-AF44-9E59622F3CF5}\InProcServer32"; ValueType: string; ValueName: ""; ValueData: "{app}\{#APP_NAME}\HostShellDll.dll"; Flags: uninsdeletevalue;
Root: HKCR32; Subkey: "CLSID\{{C08BD772-82B5-433F-AF44-9E59622F3CF5}\InProcServer32"; ValueType: string; ValueName: "ThreadingModel"; ValueData: "Apartment"; Flags: uninsdeletevalue;
Root: HKCR32; Subkey: "*\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "Directory\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "Directory\Background\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "Folder\ShellEx\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "InternetShortcut\ShellEx\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey;
Root: HKCR32; Subkey: "lnkfile\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey;
Root: HKLM32; Subkey: "Software\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved";ValueType: string; ValueName: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; ValueData: "{#SHELLEXT_NAME} Context Menu"; Flags: uninsdeletevalue;

;64bit
Root: HKCR64; Subkey: "CLSID\{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; ValueType: string; ValueName: ""; ValueData: "{#SHELLEXT_NAME} Context Menu"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "CLSID\{{C08BD772-82B5-433F-AF44-9E59622F3CF5}\InProcServer32"; ValueType: string; ValueName: ""; ValueData: "{app}\{#APP_NAME}\HostShellDll64.dll"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "CLSID\{{C08BD772-82B5-433F-AF44-9E59622F3CF5}\InProcServer32"; ValueType: string; ValueName: "ThreadingModel"; ValueData: "Apartment"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "*\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "Directory\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "Directory\Background\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "Folder\ShellEx\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "InternetShortcut\ShellEx\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKCR64; Subkey: "lnkfile\shellex\ContextMenuHandlers\{#SHELLEXT_NAME}"; ValueType: string; ValueName: ""; ValueData: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; Flags: uninsdeletekey; Check: IsWin64;
Root: HKLM64; Subkey: "Software\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved";ValueType: string; ValueName: "{{C08BD772-82B5-433F-AF44-9E59622F3CF5}"; ValueData: "{#SHELLEXT_NAME} Context Menu"; Flags: uninsdeletevalue; Check: IsWin64;



[Icons]

Name: "{group}\VMTransferFiles"; Filename: "{app}\{#APP_NAME}\VMTransferFiles.exe"
Name: "{group}\Uninstall {#APP_NAME}"; Filename: "{uninstallexe}"
Name: "{group}\ReadMe.txt"; Filename: "{app}\{#APP_NAME}\Readme.txt"


[Code]

procedure CurStepChanged_ssPostInstall;forward;
procedure CurStepChanged_ssInstall;forward;
procedure CurPageChanged_wpFinished();forward;


function CheckSigner( lpFileName : AnsiString; lpSignerName : AnsiString ) : BOOL;
external 'CheckSigner@{tmp}\InnoInstExt.dll stdcall delayload';

function IsVirtualBoxPEFile( FileName: AnsiString ) : BOOL;
begin

    Result := CheckSigner ( FileName, 'Oracle Corporation' );

    //Old signer checking

    if not Result then
        Result := CheckSigner( FileName, 'Sun Microsystems, Inc.' );

end;


procedure InitializeWizard();
var
    bRet : BOOL;
    VBoxInstallDir : AnsiString;
begin


    ExtractTemporaryFile( 'InnoInstExt.dll' );
    
    bRet := RegQueryStringValue(
        HKLM,
        'Software\Oracle\VirtualBox',
        'InstallDir',
        VBoxInstallDir
        );

    if (bRet) then
    begin
        WizardForm.DirEdit.Text := VBoxInstallDir;        
    end;
    
end;

function NextButtonClick(CurPageID: Integer): Boolean;
var
    PatchFileName : AnsiString;
begin

    Result := True;

    if ( wpSelectDir = CurPageID ) then
    begin

        //Check if correct VBox folder was selected

        PatchFileName := ExpandConstant( '{app}\VBoxGuestPropSvc.dll' );

        if not FileOrDirExists( PatchFileName ) then
        begin

          //LANG_
          MsgBox( CustomMessage( 'MsgCannotFindRequiredFiles' ), mbError, MB_OK );
          Result := False;
          Exit;

        end;
    end;
end;

procedure CurPageChanged(CurPageID: Integer);
begin

    //wpFinished
    if ( wpSelectDir = CurPageID ) then
    begin
        //
        //PAGENAMELABEL PAGEDESCRIPTIONLABEL SELECTDIRLABEL WizardForm.SelectDirBrowseLabel.Caption
        WizardForm.PageDescriptionLabel.Caption := CustomMessage( 'SelDirPageDescriptionLabel' );
        WizardForm.SelectDirLabel.Caption := CustomMessage( 'SelDirLabel' );
    end;

    if ( wpFinished = CurPageID ) then
    begin
      CurPageChanged_wpFinished();
    end;

end;


procedure CurStepChanged(CurStep: TSetupStep);

begin

  if CurStep = ssPostInstall then
  begin

    CurStepChanged_ssPostInstall();
    Exit;

  end;

  if CurStep = ssInstall then
  begin
      CurStepChanged_ssInstall();
      Exit;
  end;


end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
var
    PatchFileName : AnsiString;
    OrigBackupFileName : AnsiString;
    bRet : Boolean;

begin

    if  CurUninstallStep <> usUninstall then
        Exit;

    PatchFileName := ExpandConstant( '{app}\VBoxGuestPropSvc.dll' );
    OrigBackupFileName := ExpandConstant( '{app}\VBoxGuestPropSvc_Orig.dll' );

    bRet := FileCopy( OrigBackupFileName, PatchFileName, False );

    if ( (not bRet) and ( FileOrDirExists( OrigBackupFileName ) ) ) then
    begin
      //LANG_
        MsgBox( CustomMessage( 'MsgCannotReplaceFile' ), mbError, MB_OK );
        Abort;
        Exit;
    end;

    if bRet then
        DeleteFile( OrigBackupFileName );

end;

procedure CurStepChanged_ssInstall();
var
    PatchFileName : AnsiString;
    OrigBackupFileName : AnsiString;
    bRet : BOOL;
begin
    PatchFileName := ExpandConstant( '{app}\VBoxGuestPropSvc.dll' );
    OrigBackupFileName := ExpandConstant( '{app}\VBoxGuestPropSvc_Orig.dll' );

    if  not IsVirtualBoxPEFile( PatchFileName ) then 
    begin

        if not FileOrDirExists(OrigBackupFileName) then
        begin

            if ( IDYES <> MsgBox( CustomMessage( 'MsgCannotValidateVirtualBoxFiles' ), mbError,  MB_YESNO or MB_DEFBUTTON2) ) then
            begin
                Abort;
                Exit;
            end
            else
            begin

              bRet := FileCopy( PatchFileName, OrigBackupFileName, False )

              if not bRet then
              begin
              //LANG_
                MsgBox( CustomMessage( 'MsgCannotMakeBackupOfFile' ), mbError, MB_OK );
                Abort;
                Exit;

              end;

            end;
        end;

    end
    else
    begin

        bRet := FileCopy( PatchFileName, OrigBackupFileName, False )

        if not bRet then
        begin
          //LANG_
          MsgBox( CustomMessage( 'MsgCannotMakeBackupOfFile' ), mbError, MB_OK );
          Abort;
          Exit;

        end;

    end;

    if IsWin64() then
    begin
        ExtractTemporaryFile( 'VBoxGuestPropSvc64.dll' );
        bRet := FileCopy( ExpandConstant( '{tmp}\VBoxGuestPropSvc64.dll' ), PatchFileName, False );        
    end
    else
    begin
        ExtractTemporaryFile( 'VBoxGuestPropSvc.dll' );
        bRet := FileCopy( ExpandConstant( '{tmp}\VBoxGuestPropSvc.dll' ), PatchFileName, False );        
    end;


    if not bRet then
    begin
      //LANG_
        MsgBox( CustomMessage( 'MsgCannotReplaceFile' ), mbError, MB_OK );
        Abort;
        Exit;
    end;

end;


procedure CurStepChanged_ssPostInstall();
var
    FinishNoteLabel : TNewStaticText;
begin


    {FinishNoteLabel := TNewStaticText.Create( WizardForm );
    FinishNoteLabel.Parent := WizardForm;

    FinishNoteLabel.Left := WizardForm.FinishedLabel.Left;
    FinishNoteLabel.Top := WizardForm.FinishedLabel.Top + WizardForm.FinishedLabel.Height;

    FinishNoteLabel.Font.Color := clBlue;
    FinishNoteLabel.WordWrap := TRUE;
    FinishNoteLabel.Caption := CustomMessage( 'FinishInstallNote' );

    FinishNoteLabel.Color := WizardForm.FinishedLabel.Color;



    FinishNoteLabel.SetBounds(WizardForm.FinishedLabel.Left, FinishNoteLabel.Top, WizardForm.FinishedLabel.Width, 100 );
    FinishNoteLabel.AutoSize := False;
    WizardForm.AdjustLabelHeight( FinishNoteLabel );}


    //Changed
    //WizardForm.FinishedLabel.Caption := CustomMessage( 'FinishInstallNote' );
    //WizardForm.FinishedLabel.Font.Color := clBlue;


end;

procedure CurPageChanged_wpFinished();
begin

    //moved here to solve Reboot choice issue
    WizardForm.FinishedLabel.Caption := CustomMessage( 'FinishInstallNote' );
    WizardForm.FinishedLabel.Font.Color := clBlue;

end;


