/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _OVERWRITE_CONFIRM_H_
#define _OVERWRITE_CONFIRM_H_

#include <windows.h>


#define DLG_YES        1
#define DLG_YES_TO_ALL 2
#define DLG_NO         3
#define DLG_NO_TO_ALL  4
#define DLG_CANCEL     5

#define DLG_RETRY      6
#define DLG_SKIP	   7
#define DLG_SKIP_ALL   8



//return: DLG_YES DLG_YES_TO_ALL DLG_NO DLG_NO_TO_ALL DLG_CANCEL

int
DlgOverwriteConfirmCached(
	HINSTANCE hInst,
	LPCWSTR lpszSrcFileName,
	FILETIME *pSrcLastWriteTime,
	ULONG64 SrcFileSize,
	LPCWSTR lpszDestFileName,
	FILETIME *pDestLastWriteTime,
	ULONG64 DestFileSize,
	//should be init with zero
	int *pCachedValue
	);


int
DlgOverwriteConfirm(
	HINSTANCE hInst,
	LPCWSTR lpszSrcFileName,
	FILETIME *pSrcLastWriteTime,
	ULONG64 SrcFileSize,
	LPCWSTR lpszDestFileName,
	FILETIME *pDestLastWriteTime,
	ULONG64 DestFileSize
	);

// DLG_SKIP DLG_SKIP_ALL DLG_RETRY DLG_CANCEL

int
DlgFileIoErrorCached(
	HINSTANCE hInst,
	LPCWSTR lpszFileName,
	LPCWSTR lpMsg1,
	ULONG IoErrorCode,
	//should be init with zero
	int *pCachedValue

	);


int
DlgFileIoError(
	HINSTANCE hInst,
	LPCWSTR lpszFileName,
	LPCWSTR lpMsg1,
	ULONG IoErrorCode
	);



#endif //_OVERWRITE_CONFIRM_H_
