
/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _COPY_FILES_HANDLER_H_
#define _COPY_FILES_HANDLER_H_

#include <windows.h>

#include <vector>
#include <string>
using namespace std;

#include <pshpack1.h>

//=====================================================

#define COPY_FILES_STAGE_BUILDING_LIST			1
#define COPY_FILES_STAGE_GET_CURRENT_FILENAME	2
#define COPY_FILES_STAGE_GET_CURRENT_STREAM		3
#define COPY_FILES_STAGE_DONE                   4
#define COPY_FILES_STAGE_RELEASE_OBJ			5

//=====================================================

typedef struct COPY_FILES_BUILDING_LIST_STATUS
{
	WORD    StructSize;
	UINT64 AllStreamSize;
	UINT   FileCount;
	UINT   FolderCount;

}COPY_FILES_BUILDING_LIST_STATUS, *PCOPY_FILES_BUILDING_LIST_STATUS;

typedef struct COPY_FILES_GET_CURRENT_FILENAME
{
	WORD    StructSize;
	WCHAR   wszRelFilePath[ MAX_PATH ];
	UINT64 FileSize;
	DWORD   FileAttr;
    FILETIME FileLastWriteTime;
	BOOL     bHasStream;
    UINT64   ItemId;

} COPY_FILES_GET_CURRENT_FILENAME, *PCOPY_FILES_GET_CURRENT_FILENAME;

#include <poppack.h>

//=====================================================


//ERROR_NO_DATA
//ERROR_SUCCESS
//ERROR_NO_SYSTEM_RESOURCES

UINT
CFH_Begin(
    IN  UINT ClientId,
    IN  UINT DropHandle,
	OUT PUINT pHandle
	);

//ERROR_IO_PENDING
//ERROR_ACCESS_DENIED
//ERROR_INVALID_PARAMETER

UINT
CFH_GetBuildingListStatus(
    IN  UINT ClientId,
	IN  UINT Handle,
	OUT PCOPY_FILES_BUILDING_LIST_STATUS pCopyFilesBuildingListStatus
	);

//ERROR_ACCESS_DENIED
//ERROR_INVALID_PARAMETER
//ERROR_NO_MORE_FILES

UINT
CFH_GetCurrentFileName(
    IN  UINT ClientId,
	IN  UINT Handle,
	OUT PCOPY_FILES_GET_CURRENT_FILENAME pCopyFilesGetCurrentFileName
	);

//ERROR_NO_DATA
//ERROR_OPEN_FAILED
//ERROR_HANDLE_EOF
//ERROR_READ_FAULT

UINT
CFH_GetCurrentStream(
    IN  UINT ClientId,
	IN  UINT Handle,
	IN OUT PVOID pBuffer,
	IN  UINT BufferSize,
	OUT PUINT pBytesCopied,
	OUT PUINT64 pStreamOffset
	);

UINT
CFH_ClientDisconnected(
	IN  UINT ClientId
	);

//ERROR_NO_MORE_FILES

UINT
CFH_MoveToNextItem(
    IN  UINT ClientId,
	IN  UINT Handle,
	UINT64 ItemId
	);


VOID
CFH_Dump(
	IN  UINT Handle
    );

UINT
CFH_End(
	IN  UINT ClientId,
	IN  UINT Handle
	);


typedef
BOOL
(CALLBACK *TFILELISTTOCOPYHANDLER)(
    UINT DropHandle,
    vector<wstring> *pClipboardFileList
    );

BOOL
CALLBACK
StandardGetCopiedFileListHandler(
    UINT DropHandle,
    vector<wstring> *pClipboardFileList
    );

TFILELISTTOCOPYHANDLER
SetGetCopiedFileListHandler( TFILELISTTOCOPYHANDLER pNewHandler );

#endif //_COPY_FILES_HANDLER_H_

