/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _FILES_COPIER_H_
#define _FILES_COPIER_H_

#include "CopyFilesHandler.h"
#include <VBox/types.h>

class CFileCopierHelper
{
public:

    CFileCopierHelper(){};
    virtual ~CFileCopierHelper(){}

    virtual
    UINT
    CFH_Begin(
        IN uint32_t ClientId,
        IN uint32_t DropHandle,
        OUT uint32_t *pHandle
        ) PURE;

    virtual
    UINT
    CFH_GetBuildingListStatus(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	OUT PCOPY_FILES_BUILDING_LIST_STATUS pCopyFilesBuildingListStatus
    	) PURE;

    virtual
    UINT
    CFH_GetCurrentFileName(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	OUT PCOPY_FILES_GET_CURRENT_FILENAME pCopyFilesGetCurrentFileName
    	) PURE;

    virtual
    UINT
    CFH_GetCurrentStream(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	IN OUT PVOID pBuffer,
    	IN  UINT BufferSize,
    	OUT PUINT pBytesCopied,
    	OUT PUINT64 pStreamOffset
    	) PURE;

    virtual
    UINT
    CFH_MoveToNextItem(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	UINT64 ItemId
    	) PURE;

    virtual
    UINT
    CFH_End(
    	IN  UINT ClientId,
    	IN  UINT Handle
    	) PURE;

}; //CFileCopierHelper

//returns count indicated how many create operations were succeeded

ULONG
ProceeedCopyingFiles(
    CFileCopierHelper *pCopyingHelper,
    uint32_t ClientId,
    uint32_t DropHandle,
    LPCWSTR lpszDestFolderName
    );


#endif //_FILES_COPIER_H_
